﻿=pod

A component of Matrix-Math© by Nova Software, Inc.

Copyright © by Nova Software, Inc. 2022  All rights reserved.  http://www.nova-sw.com

=cut
  package O_I ; use strict; use warnings; use utf8; use File::Copy; use Data::Dumper; our $VERSION = 0.220321; our $Release = '2.0'; our $DEBUG = $ARGV[1] ? $ARGV[1] : 0 ;  BEGIN { $DEBUG = 0 }  use O_X 0.220316;
use O_H 0.220304; use constant dxI => '****DIE****: '; use constant avI => '**WARNING**: ';  $|  = 1; my %lgI = ();  my @kmI = ();  my @ijI = (); my $oqI = 0; my $kuI = 0; my $sqI = tmH();  my $fwI = yzH();  my $bdI = o2H();  my $jcI = '│ ';  our $Delta = 1.0e-15; our $Rect = 1; our $Wrns = 1; our $Output = 1; our $Notes = 1; our $NBO_file = 0; our $First_cmd = 1;
$SIG{__DIE__}  = sub { print dxI."@_\n" ; exit 1; };  $SIG{__WARN__} = sub { my $qyI = avI."@_"; warn "$qyI\n";  push @ijI, ("$jcI$qyI$jcI\n") if $Wrns; $oqI++; }; sub yaI { i6I(); my $imI = $ARGV[0]; die "A notebook filepathname (*.nbk) is required: $imI " unless ($imI and $imI =~/.+\.nbk$/); my $cgI = time(); my $xdI = localtime($cgI); open FH, "<:utf8", $imI or die "Can't open '$imI': $!\n"; @kmI = <FH>; close FH; binmode(STDOUT, ':utf8'); print "$xdI\n" if $DEBUG; @ijI = ("$jcI\n$jcI $xdI\n"); my $kwI = "$jcI\n$jcI Special non-keyboard input symbols: (Copy: Ctrl+c, Paste: Ctrl+v)\n".
"$jcI ⁰ ˉ¹ ² ³ ⁴ ⁵ ⁶ ⁷ ⁸ ⁹ π √ î ☀ ∙ ± † ᵀ ᴿ ½ ⅓ ¼ ⅔ ¾ Î Ʉ Ⱦ Ⱥ Ȼ Ħ ê « » \n". "$jcI Some require a UTF-8 enabled font to display properly.\n$jcI\n".  "$jcI More info in 'command_summary.nbo' and 'M-M_Reference.nbk'.\n$jcI\n";  push @ijI, $kwI; my $rmI = 0; my $aoI = quotemeta avI; my $n1I = 0; my $ywI = quotemeta faH; $kuI = 0 ; while ($_ = shift @kmI) {  $kuI++; print "$kuI:\n$_" if ($DEBUG and $_!~/^│/); next if /^│/; push @ijI, $_  if (!$NBO_file or ($Output and $_!~/^\s*!/));  next unless /^(\s*)«|^(\s*)<</; my $tsI = ''; $tsI = $1 if $1; $tsI = $2 if $2; my ($laI, $pxI, $hwI) = jkI($_);  $hwI ||= '';
if (my @oiI = $hwI=~/$aoI/g) { $rmI += @oiI } unless (defined $pxI) { $rmI++; my $qyI = avI."No result for $_ .\n$jcI$hwI\n"; print $qyI; push @ijI, $jcI.$qyI if ($Wrns and (!$NBO_file or $Output)); } if (ref $pxI eq 'HASH') { local $_; if (!$NBO_file or $Output) { push @ijI, "$jcI$tsI"."EXP\n" if ( ${$pxI->{EXP}} eq 'EXP' ) ; push @ijI, "$jcI$tsI"."EXPᴿ\n" if ( ${$pxI->{EXP}} eq 'EXPᴿ' ) ; push @ijI, "$jcI$tsI${$pxI->{coeff}} * \n" ; push @ijI, "$jcI$tsI@$_\n"  foreach (@{$pxI->{matrix}}); push @ijI, "$jcI$tsI${$pxI->{note}}\n" if ($Notes and $pxI->{note} and ${$pxI->{note}}) ; push @ijI, "$jcI$hwI\n" if ($hwI and $Wrns) ; }
$lgI{$laI} = $pxI if $laI ; if ($DEBUG) { local $_; print $tsI."EXP\n" if ( ${$pxI->{EXP}} eq 'EXP' ) ; print $tsI."EXPᴿ\n" if ( ${$pxI->{EXP}} eq 'EXPᴿ' ) ; print $tsI.${$pxI->{coeff}}." * \n"; print $tsI."@$_\n" foreach (@{$pxI->{matrix}}) ; print $tsI.${$pxI->{note}}."\n" if ($Notes and $pxI->{note} and ${$pxI->{note}}) ; print "$hwI\n" if $hwI ; } } elsif (ref $pxI eq 'ARRAY') {  local $_; if (!$NBO_file or $Output) { push @ijI, "$jcI$tsI@$_\n"  foreach (@$pxI); push @ijI, $jcI.$hwI if ($hwI and $Wrns) ; } my $pyI = 1; my $o4I = '';
my $jpI = 0; $lgI{$laI} = { coeff => \$pyI, matrix => $pxI, note => \$o4I, EXP => \$jpI} if $laI ;  if ($DEBUG) { local $_; print $tsI."@$_\n" foreach (@$pxI) ; print $hwI if $hwI ; } } elsif (ref $pxI eq 'SCALAR') { my $tmp = ($hwI and $Wrns) ? "$jcI$hwI\n" : ''; my $tmp2 = $$pxI=~/^│/ ? '' : $jcI ; chomp $$pxI;  push @ijI, "$tmp2$tsI$$pxI\n$tmp"  if (!$NBO_file or $Output) ; $lgI{$laI} = $pxI if $laI; print $tsI."$$pxI\n$hwI\n" if $DEBUG } else {  if ($pxI) {  if (my @oiI = $pxI =~/$ywI/g ) {
$n1I += @oiI  } if (my @oiI = $pxI=~/$aoI/g) { $rmI += @oiI; } $pxI .= " $imI line $kuI \n" if $pxI =~/$ywI|$aoI/; print $tsI."$pxI\n"; my $tmp = $pxI=~/^│/ ? '' : $jcI ; chomp $pxI; push @ijI, "$tmp$tsI$pxI\n" if (!$NBO_file or $Output); } } $First_cmd = 0; } my $fiI = time(); my $jfI = $fiI - $cgI; my $gqI = localtime($fiI); my $jnI = $rmI + $oqI; my $qyI = "$jcI\n$jcI End file '$imI'\n";
$qyI .= "$jcI for Matrix-Math© r$Release \n"; $qyI .= "$jcI by Nova Software, www.nova-sw.com\n$jcI\n"; $qyI .= "$jcI Elapsed time = $jfI secs.\n$jcI $gqI\n"; $qyI .= "$jcI\n$jcI $n1I errors and $jnI warnings \n$jcI\n" ; print $qyI; push @ijI, $qyI ; my $a2I = ''; if ($NBO_file) { $imI =~s/\.nbk$/\.nbo/; $a2I = $imI; $a2I =~s/\.nbo$/-prv.nbo/; } else {  $a2I = $imI; $a2I =~s/\.nbk$/-prv.nbk/; } copy $imI, $a2I;  open FH, ">:utf8", $imI or die "Can't open '$imI': $!\n"; print FH @ijI; close FH;
}  sub jkI { my $qaI = shift; chomp $qaI; my ($laI, $peI, @fbI) = dtI($qaI); return ($laI, $peI->(@fbI)) if ref $peI;  return ($laI, $peI) ;  } {  my %dkI = ( '*'   => \&dqX, '*ᴿ'  => \&uzX, '^'  => \&khX, '^ᴿ'  => \&rfX, '+'   => \&hfX, '-'   => \&qtX, '?=' => \&ntX, '(+)' => \&kxX, '(+)ᴿ' => \&gnX, '(X)' => \&hzX,
); my $luI = faH."Unknown operation: "; my $rnI = faH."Unknown name: "; my $enI = faH."Missing command bracket: "; my $gbI = faH."Invalid coefficient:"; my $bwI = faH."Matrix coefficient must be a scalar, not another matrix:"; my $jaI = faH."Cannot modify a default matrix:";  sub dtI { my $qaI = shift; return ('', faH."Missing command.") unless $qaI=~/\w/;  my @crI = split ' ',$qaI;  my $elI = shift @crI ;  my $jdI = $elI eq '«' ?  '»' : '>>' ; return ('', "$jaI '$crI[0]'") if ($crI[0]=~/^[ÎȺĦȾȻɄ][r\d]+$/ and not @crI );  my $qyI = ''; if ($crI[-1] eq '=') { my $ciI = ckI($crI[0]); return ('', $ciI) if $ciI; return ($crI[0], \&m3I , $jdI, '' ) }
elsif ($crI[-1] eq '*') { my $ciI = ckI($crI[0]); return ('', $ciI) if $ciI; my $foI = 1; if ( ref $lgI{$crI[2]} eq 'HASH') { return ('', "$bwI '$crI[2]'")     } elsif ( ref $lgI{$crI[2]} eq 'SCALAR') { $foI = ${$lgI{$crI[2]}} } elsif ( $crI[2]=~/($fwI)/ and $crI[2] != 0) { $foI = $crI[2] } elsif ( $crI[2] and $crI[2]=~/($sqI)|($bdI)/) {  $foI = $crI[2]  } else { return ('', "$gbI '$crI[2]' ") } return ($crI[0], \&m3I , $jdI, $foI )
}  elsif ($crI[-1] eq $jdI ) { pop @crI;  if ($crI[2] and $crI[2] eq '=' and $crI[1] and $crI[1] eq 'coeff') { return ('', "$rnI '$crI[0]' ") unless defined $lgI{$crI[0]} ; return ('', "$gbI '$crI[3]' ") if ($crI[3]=~/$fwI/ and $crI[3] == 0);                 return ('', \&dyI, $crI[0], $crI[3]); } elsif ($crI[2] and $crI[2] eq '=' and $crI[1] and $crI[1] eq 'note') { return ('', "$rnI '$crI[0]' ") unless defined $lgI{$crI[0]} ; my $eyI = @crI-1;  return ($crI[0], \&cmI, $crI[0], @crI[3..$eyI]); } elsif ( $crI[1] and $crI[1] eq '=') { my $laI = shift @crI; my $ciI = ckI($laI); return ('', $ciI) if $ciI; shift @crI; 
if ($crI[0] and $crI[0] eq 'diag') { shift @crI; return ($laI, \&o3I, @crI) ; } elsif ($crI[0] and $crI[0] eq 'rdiag') { shift @crI; return ($laI, \&zcI, @crI) ; } elsif (@crI == 1) {  if ($crI[0] =~/^(\w+)ˉ¹$/ ) { my $qlI = $1; return ('',"$rnI $qlI") unless defined $lgI{$qlI}; return ($laI, \&azX, $lgI{$qlI} ) } elsif ($crI[0] =~/^(\w+)ˉ¹ᴿ$/ ) { my $qlI = $1; return ('',"$rnI $qlI") unless defined $lgI{$qlI}; return ($laI, \&q1X, $lgI{$qlI} )
} elsif ($crI[0] =~/^(\w+)ᵀ$/ ) { my $qlI = $1; return ('',"$rnI $qlI") unless defined $lgI{$qlI}; return ($laI, \&s1X, $lgI{$qlI} ) } elsif ($crI[0] =~/^(\w+)ᵀᴿ$/ ) {  my $qlI = $1; return ('',"$rnI $qlI") unless defined $lgI{$qlI}; return ($laI, \&s1X, $lgI{$qlI}, 1 ) } elsif ($crI[0] =~/(\w+)†$/ ) { my $qlI = $1; return ('',"$rnI $qlI") unless defined $lgI{$qlI}; return ($laI, \&bcX, $lgI{$qlI}, 0) } elsif ($crI[0] =~/(\w+)†ᴿ$/ ) {
my $qlI = $1; return ('',"$rnI $qlI") unless defined $lgI{$qlI}; return ($laI, \&bcX, $lgI{$qlI}, 1 ) } elsif ($crI[0] =~/(\w+)☀$/ ) { my $qlI = $1; return ($laI, \&vpX, $lgI{$qlI} ) if defined $lgI{$qlI}; return ($laI, \&qmI, $laI, $crI[0] );   } elsif ( ref $lgI{$crI[0]} eq 'HASH') { return ($laI, \&fnX, $lgI{$crI[0]}) } else { return ($laI, \&qmI, $laI, $crI[0] ) } }  elsif (@crI == 2) { my $apI = shift @crI; my $wkI = shift @crI;  return ('',"$rnI $wkI")
unless defined $lgI{$wkI}; if ($apI eq 'coeff') { return ('', "$rnI '$wkI' ") unless defined $lgI{$wkI} ; return ($laI, \&boI, $laI, $wkI, ); } return ($laI, \&xiX, $lgI{$wkI} ) if ($apI eq 'det') ; return ($laI, \&h4X, $lgI{$wkI} ) if ($apI eq 'Tr'); return ($laI, \&u1X, $lgI{$wkI} ) if ($apI eq 'Trᴿ'); return ($laI, \&kjI, $lgI{$wkI} ) if ($apI eq 'alias'); return ($laI, \&oyX, $lgI{$wkI} ) if ($apI eq 'flip'); return ($laI, \&stI, $lgI{$wkI} ) if ($apI eq 'EXP'); return ($laI, \&stI, $lgI{$wkI}, 'EXPᴿ' ) if ($apI eq 'EXPᴿ'); return ($laI, \&a1X, $lgI{$wkI} )
if ($apI eq 'rank'); $qyI = "$luI '$apI' "; }  elsif (@crI == 3) {  if ($crI[0]=~/^multiply$/i and $crI[1]=~/^coeff$/i ) { return ('',"$rnI '$crI[2]' ") unless defined $lgI{$crI[2]}; return ($laI, \&djX, $lgI{$crI[2]} ); } else { my $wsI = defined $lgI{$crI[0]} ? $lgI{$crI[0]} : $crI[0]; my $rcI = defined $lgI{$crI[2]} ? $lgI{$crI[2]} : $crI[2]; return ($laI, $dkI{$crI[1]}, $wsI, $rcI ) if defined $dkI{$crI[1]} ; } $qyI = "$luI '$crI[1]' "; } elsif (@crI == 4) { } elsif (@crI == 5) {
return ('',"$rnI '$crI[1]' ") unless defined $lgI{$crI[1]}; return ('',"$rnI '$crI[3]' ") unless defined $lgI{$crI[3]}; return ($laI, \&thX, $lgI{$crI[1]}, $lgI{$crI[3]} ) if ( $crI[0] eq '[' and $crI[2] eq ',' and $crI[4] eq ']' ); return ($laI, \&brX, $lgI{$crI[1]}, $lgI{$crI[3]} ) if ( $crI[0] eq '[' and $crI[2] eq ',' and $crI[4] eq ']ᴿ' ); return ($laI, \&ztX, $lgI{$crI[1]}, $lgI{$crI[3]} ) if ( $crI[0] eq '{' and $crI[2] eq ','
and $crI[4] eq '}' ); return ($laI, \&tvX, $lgI{$crI[1]}, $lgI{$crI[3]} ) if ( $crI[0] eq '{' and $crI[2] eq ',' and $crI[4] eq '}ᴿ' ); }  }  elsif ($crI[0] eq 'delete') { return ('', \&kvI, @crI )                } elsif (@crI == 2) {  return ('', \&lvI, $crI[1] ) if ($crI[0] eq 'size' ); return ('', \&ubI, $crI[1], 'coeff' ) if ($crI[0] eq 'coeff' ); return ('', \&ubI, $crI[1], 'note' ) if ($crI[0] eq 'note' );
return ('', \&ubI, $crI[1], 'EXP' ) if ($crI[0] eq 'EXP' ); return ('', \&pwI, $crI[1] )  if $crI[0] =~/^show$/i; return ('', \&blI, $crI[1] )  if $crI[0] =~/^list$/i; return ('', \&zkI, $crI[0], $crI[1]  )  if $crI[0] =~/^rectangular$|^warning|^output$|^note|^sidebar|^\.?nbo_file/i ; return ('', \&zkI,  $crI[0], $crI[1] )  if $crI[0] =~/^delta$/i ; } elsif (@crI == 1) { return ('', \&cbI, $lgI{$crI[0]} ) if defined $lgI{$crI[0]} ; }  }  else { $qyI = "$enI $qaI " }  $qyI ||= "$luI $qaI " ; return ('', $qyI);  } 
}  sub ckI { my $ewI = shift; my $dfI = ''; $dfI .= "Name '$ewI' must start with any alphabetic character except 'πêîÎȺȻĦȾɄ'." if $ewI =~/^_|^\d|^[ÎȺĦȾȻɄπêî]/; $dfI .= "Name '$ewI' may contain only alphanumeric characters and _. " if $ewI =~/\W/; $dfI .= "Name '$ewI' is predefined and reserved. Please choose another. " if $ewI =~/^($O_H::Fctn_nms$|EXP)$/; $dfI = faH.$dfI if $dfI; $dfI } sub cbI { ($_[0], '') } sub kjI {$_[0]};  sub lvI { my $sfI = shift; return  faH."Undefined object $sfI" unless $lgI{$sfI}; my $i2I = $lgI{$sfI}; return ($i2I, avI."A scalar, not a matrix ")
if (ref $i2I eq 'SCALAR'); my $pbI = ref $i2I eq 'ARRAY' ? $i2I : $i2I->{matrix};   my $rzI = scalar @$pbI; my $i8I = scalar @{$pbI->[0]}; my $qyI = ''; $qyI = avI."Rectangular matrix ($rzI,$i8I)" if ($rzI>1 and $i8I>1 and $rzI != $i8I); my $pxI = "($rzI, $i8I)"; return (\$pxI, $qyI) ; } sub ubI { my $ewI = shift; my $yiI = shift; return faH."'$ewI' must be a matrix." unless (ref $lgI{$ewI} eq 'HASH'); return "coeff of matrix $ewI  = ${$lgI{$ewI}->{coeff}}" if $yiI eq 'coeff'; return "note for matrix $ewI : ${$lgI{$ewI}->{note}}" if $yiI eq 'note'; return ${$lgI{$ewI}->{EXP}} ? ${$lgI{$ewI}->{EXP}} : 'none' if ( $yiI eq 'EXP' ) ; return ''; }
sub m3I  { my ($jdI, $foI) = @_; $jdI ||= '»'; $foI ||= '';  my $hnI = []; while ($_ = shift @kmI) { $kuI++; next if /^│/; push @ijI, $_  if (!$NBO_file or ($Output and $_!~/^\s*!/));  chomp ; next if /^\s*$/;  last if /^\s*$jdI\s*$/; push @$hnI, [split] ; } return faH."Cannot define an empty matrix." unless @$hnI; my $nfI = @{$hnI->[0]};  foreach (@$hnI) { $nfI = @$_ if @$_>$nfI  }
my $egI = 0; foreach my $dpI (0 .. $#$hnI) { foreach my $vnI (0 .. $nfI-1) { unless (defined $hnI->[$dpI][$vnI]) { $hnI->[$dpI][$vnI] = 0 ; $egI++; } return faH."$hnI->[$dpI][$vnI] is not a recognized matrix entry." unless $hnI->[$dpI][$vnI]=~/($fwI)|($sqI)|($bdI)/; } } my $qyI = ''; $qyI = avI."0 filled '$egI' missing trailing entries " if $egI; my $dfI = $qyI ? "\n$jcI" : ''; my $haI = @$hnI ; if ( $haI>1 and $nfI>1 and $haI != $nfI ) { return faH."Rectangular matrices are not accepted. $haI rows x $nfI cols  "  unless $Rect;      $qyI .= $dfI.avI."Rectangular matrix: $haI rows x $nfI cols ";
} my $pyI = $foI ? $foI : 1;  my $toI = ''; my $jpI = ''; my $irI = { coeff   => \$pyI, matrix  => $hnI, note    => \$toI, EXP =>  \$jpI }; return ($irI, $qyI); } sub o3I { my @ikI = @_; return faH."Cannot define an empty matrix." unless @ikI; my $mqI = @ikI - 1;  my $xjI = []; foreach my $dpI (0 .. $mqI){ foreach my $vnI (0 .. $mqI){ $xjI->[$dpI][$vnI] = $dpI==$vnI ? $ikI[$dpI] : 0;
} } my $gzI = 1; my $jpI = ''; my $o4I = ''; { coeff => \$gzI, matrix => $xjI, note => \$o4I, EXP => \$jpI } } sub zcI { my @ikI = @_; return faH."Cannot define an empty matrix." unless @ikI; my $iqI = @ikI - 1; my $xjI = []; foreach my $dpI (0 .. $iqI){ foreach my $vnI (0 .. $iqI){  my $lbI = $iqI-$vnI ; 
$xjI->[$dpI][$lbI] = $lbI==$iqI-$dpI ? $ikI[$dpI] : 0; } } my $gzI = 1; my $jpI = ''; my $o4I = ''; { coeff => \$gzI, matrix => $xjI, note => \$o4I, EXP => \$jpI } } sub stI { my $i2I = shift; my $gwI = shift; $gwI ||= 'EXP';   return faH."Not a matrix, no matrix exponentiation. " unless ref $i2I eq 'HASH'; return faH."This matrix is already exponentiated. Cannot do another. "
if ${$i2I->{EXP}}; my $deI = fnX($i2I); my $toI = ''; $deI->{note} = \$toI; $deI->{EXP} = \$gwI;  $deI } sub boI { my ($laI, $gkI) = @_; $lgI{$laI} = $lgI{$gkI}->{coeff}; return ''; } sub dyI { my ($laI, $grI) = @_; return faH."'$laI' must be a matrix to have a coefficient." unless (ref $lgI{$laI} eq 'HASH'); my $dfI = "$laI coeff = "; if ( ref $lgI{$grI} eq 'SCALAR') {  $lgI{$laI}->{coeff} = $lgI{$grI}; $dfI .= "${$lgI{$grI}}, value of $grI scalar."
} my $ywI = lfI($grI); return $ywI if $ywI; $lgI{$laI}->{coeff} = \$grI; $dfI .= "$grI"; return $dfI } sub cmI { my ($laI, @rkI) = @_; return faH."'$laI' must represent a matrix to have a note." unless (ref $lgI{$laI} eq 'HASH'); my $tmp = join ' ', @rkI;   $lgI{$laI}->{note} = \$tmp; return $lgI{$laI}; } sub qmI { my ($laI, $ghI) = @_; if (ref $lgI{$ghI} eq 'SCALAR') { my $zaI = ${$lgI{$ghI}};  return \$zaI;
} my $ywI = lfI($ghI); return $ywI if $ywI; return \$ghI } sub lfI { my $mkI = shift; my $qyI = faH."'$mkI' is not a recognized scalar value. (number, expression, function, or complex value)"; if ( $mkI=~/($fwI)|($sqI)|($bdI)/) { return ''} return $qyI } sub i6I { my @ibI = <DATA>; shift @ibI;  my $laI = ''; my $hnI = []; my $toI = ''; my $foI = 1; my $naI = ''; foreach (@ibI) {
chomp; unless ( $_) {  my $pyI = $foI;  my $fzI = $toI; my $vsI = $naI; my $eyI = ''; if ($laI) { if (@$hnI) { $lgI{$laI} = { matrix => $hnI, coeff => \$pyI, note => \$fzI, EXP => \$eyI } } else { $lgI{$laI} = \$vsI } } $laI=$toI=''; $hnI=[]; $foI=1; $naI='', $eyI=''; next;
} elsif (/^[^[:ascii:]]/) { my @crI = split; $laI = $crI[0]; if (defined $crI[1] and $crI[1] eq '=') { $naI = $crI[2] if @crI==3; $foI = $crI[2] if (@crI==4 and $crI[3] eq '*'); } } elsif (/^:/) { $toI = $_; $toI =~s/^:// } else { my @tmp = split; push @$hnI, \@tmp if @tmp; } } } sub pwI { 
my $yiI = shift; $yiI ||= 'all';  return faH."Unrecognized show type: '$yiI' "    unless $yiI=~/^all$|^mine$|^defaults$|^scalars$|^matrices$/; my $dfI = ''; foreach my $laI (sort keys %lgI) { next if ($yiI eq 'mine' and $laI =~/^[ÎȺĦȾȻɄ]/); next if ($yiI eq 'defaults' and $laI !~/^[ÎȺĦȾȻɄ]/); if ( ref $lgI{$laI} eq 'SCALAR' and $yiI ne 'matrices') { $dfI .= "$jcI\n$jcI $laI = ${$lgI{$laI}}\n" ; } elsif ( ref $lgI{$laI} eq 'HASH' and $yiI ne 'scalars') { $dfI .= "$jcI\n$jcI $laI = \n"; $dfI .= "$jcI EXP\n" if ${$lgI{$laI}->{EXP}}; $dfI .= "$jcI ${$lgI{$laI}->{coeff}} * \n"; $dfI .= "$jcI @$_\n" foreach (@{$lgI{$laI}->{matrix}}) ; $dfI .= "$jcI ${$lgI{$laI}->{note}}\n" if ${$lgI{$laI}->{note}} } }
return \$dfI } sub blI {  my $yiI = shift; $yiI ||= 'all';  return faH."Unrecognized list type: '$yiI' "    unless $yiI=~/^all$|^mine$|^defaults$|^scalars$|^matrices$/; my $dfI = ''; foreach my $laI (sort keys %lgI) { next if ($yiI eq 'mine' and $laI =~/^[ÎȺĦȾȻɄ]/); next if ($yiI eq 'defaults' and $laI !~/^[ÎȺĦȾȻɄ]/); if ( ref $lgI{$laI} eq 'SCALAR' and $yiI ne 'matrices') { $dfI .= "$jcI $laI \n" } elsif ( ref $lgI{$laI} eq 'HASH' and $yiI ne 'scalars') { my ($wzI, $aoI) = lvI($laI); my $toI = ${$lgI{$laI}->{note}} ? ${$lgI{$laI}->{note}} : ''; $dfI .= "$jcI $laI $$wzI  $toI\n"; } }
return \$dfI } sub kvI { shift @_;   my @emI = @_; my ($skI, $mgI) = ('',''); foreach (@emI) { if (exists $lgI{$_} ) { delete $lgI{$_}; $skI .= "$_ ";  } else { $mgI .= "$_ ";   } } $skI = 'Deleted: '.$skI if $skI; $mgI = avI.'Names not found: '.$mgI if $mgI;  my $roI = $skI ? "\n$jcI" : '';   return $skI.$roI.$mgI ; }
sub zkI { my ($o1I, $mkI) = @_;  if ($mkI =~$fwI) { $Delta = $mkI if $o1I =~/^delta$/; return ''; } elsif ($mkI =~/^on$/i) { $mkI = 1 } elsif ($mkI =~/^off$/i) { $mkI = 0 } else { return faH."'$o1I $mkI' is an incomplete or incorrect command." } $Wrns = $mkI , return ' ' if $o1I =~/^warning(s)?$/i; $Rect = $mkI , return ' ' if $o1I =~/^rectangular$/i; $Notes = $mkI , return ' ' if $o1I =~/^note(s)?$/i; if ($o1I=~/^\.?nbo_file$/i) { if ( $First_cmd ) { $NBO_file = $mkI; return ' ' ; } else {
return faH."'$o1I' must be the first command in the file. No change."; } } elsif ($o1I =~/^output$/i) { $Output = $mkI , return ' ' } elsif ($o1I =~/^sidebar(s)?$/i) { if ($NBO_file) { $jcI = $mkI ? '│ ' : ''; return ' '; } else { return faH."Sidebar directives require an *.nbo file. No change."; } } return faH."$o1I $mkI is an unknown directive." } 1;
__DATA__
CBxBFXq3IGRwQwaE1sjvyQ

Î1 = 
 1
:1st order identity 

Î2 =
 1 0
 0 1
:2nd order identity

Î3 =
 1 0 0
 0 1 0
 0 0 1
:3rd order identity

Î4 = 
 1 0 0 0
 0 1 0 0
 0 0 1 0
 0 0 0 1
:4th order identity

Î5 = 
 1 0 0 0 0
 0 1 0 0 0
 0 0 1 0 0
 0 0 0 1 0
 0 0 0 0 1
:5th order identity

Î6 = 
 1 0 0 0 0 0
 0 1 0 0 0 0
 0 0 1 0 0 0
 0 0 0 1 0 0
 0 0 0 0 1 0
 0 0 0 0 0 1
:6th order identity

Î7 = 
 1 0 0 0 0 0 0
 0 1 0 0 0 0 0
 0 0 1 0 0 0 0
 0 0 0 1 0 0 0
 0 0 0 0 1 0 0
 0 0 0 0 0 1 0
 0 0 0 0 0 0 1
:7th order identity

Î8 = 
 1 0 0 0 0 0 0 0
 0 1 0 0 0 0 0 0
 0 0 1 0 0 0 0 0
 0 0 0 1 0 0 0 0
 0 0 0 0 1 0 0 0
 0 0 0 0 0 1 0 0
 0 0 0 0 0 0 1 0
 0 0 0 0 0 0 0 1
:8th order identity

Î9 = 
 1 0 0 0 0 0 0 0 0
 0 1 0 0 0 0 0 0 0
 0 0 1 0 0 0 0 0 0
 0 0 0 1 0 0 0 0 0
 0 0 0 0 1 0 0 0 0
 0 0 0 0 0 1 0 0 0
 0 0 0 0 0 0 1 0 0
 0 0 0 0 0 0 0 1 0
 0 0 0 0 0 0 0 0 1
:9th order identity

Îr1 = 
 1
:1st order right-hand identity 

Îr2 =
 0 1
 1 0
:2nd order right-hand identity

Îr3 =
 0 0 1
 0 1 0
 1 0 0
:3rd order right-hand identity

Îr4 = 
 0 0 0 1
 0 0 1 0
 0 1 0 0
 1 0 0 0
:4th order right-hand identity

Îr5 = 
 0 0 0 0 1
 0 0 0 1 0
 0 0 1 0 0
 0 1 0 0 0
 1 0 0 0 0
:5th order right-hand identity

Îr6 = 
 0 0 0 0 0 1
 0 0 0 0 1 0
 0 0 0 1 0 0
 0 0 1 0 0 0
 0 1 0 0 0 0
 1 0 0 0 0 0
:6th order right-hand identity

Îr7 = 
 0 0 0 0 0 0 1
 0 0 0 0 0 1 0
 0 0 0 0 1 0 0
 0 0 0 1 0 0 0
 0 0 1 0 0 0 0
 0 1 0 0 0 0 0
 1 0 0 0 0 0 0
:7th order right-hand identity

Îr8 = 
 0 0 0 0 0 0 0 1
 0 0 0 0 0 0 1 0
 0 0 0 0 0 1 0 0
 0 0 0 0 1 0 0 0
 0 0 0 1 0 0 0 0
 0 0 1 0 0 0 0 0
 0 1 0 0 0 0 0 0
 1 0 0 0 0 0 0 0
:8th order right-hand identity

Îr9 = 
 0 0 0 0 0 0 0 0 1
 0 0 0 0 0 0 0 1 0
 0 0 0 0 0 0 1 0 0
 0 0 0 0 0 1 0 0 0
 0 0 0 0 1 0 0 0 0
 0 0 0 1 0 0 0 0 0
 0 0 1 0 0 0 0 0 0
 0 1 0 0 0 0 0 0 0
 1 0 0 0 0 0 0 0 0
:9th order right-hand identity

Ʉ1 = 1/2 *
 0 1
 1 0
:First Lalg generator of the SU(2) fundamental IRR in the Pauli basis 

Ʉ2 = 1/2 *
 0 -î
 î  0
:Second Lalg generator of the SU(2) fundamental IRR in the Pauli basis

Ʉ3 = 1/2 *
 1  0
 0 -1
:Third Lalg generator of the SU(2) fundamental IRR in the Pauli basis

Ʉr1 = 1/2 *
 1 0
 0 1
:First righthand Lalg generator of the SU(2) fundamental IRR in the Pauli basis

Ʉr2 = 1/2 *
 -î 0
  0 î
:Second righthand Lalg generator of the SU(2) fundamental IRR in the Pauli basis

Ʉr3 = 1/2 *
  0 1
 -1 0
:Third righthand Lalg generator of the SU(2) fundamental IRR in the Pauli basis

Ȼ1 = 1/2 *
 0 1 0
 1 0 0
 0 0 0
:First Lalg generator of the su(3) fundamental IRR in the Gell-Mann basis

Ȼ2 = 1/2 *
 0 -î 0
 î  0 0
 0  0 0
:Second Lalg generator of the su(3) fundamental IRR in the Gell-Mann basis

Ȼ3 = 1/2 *
 1  0 0
 0 -1 0
 0  0 0
:Third Lalg generator of the su(3) fundamental IRR in the Gell-Mann basis

Ȼ4 = 1/2 *
 0 0 1
 0 0 0
 1 0 0
:Fourth Lalg generator of the su(3) fundamental IRR in the Gell-Mann basis

Ȼ5 = 1/2 *
 0 0 -î
 0 0  0
 î 0  0
:Fifth Lalg generator of the su(3) fundamental IRR in the Gell-Mann basis

Ȼ6 = 1/2 *
 0 0 0
 0 0 1
 0 1 0
:Sixth Lalg generator of the su(3) fundamental IRR in the Gell-Mann basis

Ȼ7 = 1/2 *
 0 0  0
 0 0 -î
 0 î  0
:Seventh Lalg generator of the su(3) fundamental IRR in the Gell-Mann basis

Ȼ8 = 1/2√3 *
 1 0  0
 0 1  0
 0 0 -2
:Eighth Lalg generator of the su(3) fundamental IRR in the Gell-Mann basis

Ȼ9 = 1/2 *
 0 0  0
 0 1  0
 0 0 -1
:Ninth Lalg generator for the su(3) singlet IRR in the Gell-Mann basis

Ȼr1 = 1/2 *
 0 1 0
 0 0 1
 0 0 0
:First righthand Lalg generator of the su(3) fundamental IRR in the Gell-Mann basis

Ȼr2 = 1/2 *
 0 -î 0
 0  0 î
 0  0 0
:Second righthand Lalg generator of the su(3) fundamental IRR in the Gell-Mann basis

Ȼr3 = 1/2 *
 0  0 1
 0 -1 0
 0  0 0
:Third righthand Lalg generator of the su(3) fundamental IRR in the Gell-Mann basis

Ȼr4 = 1/2 *
 1 0 0
 0 0 0
 0 0 1
:Fourth righthand Lalg generator of the su(3) fundamental IRR in the Gell-Mann basis

Ȼr5 = 1/2 *
 -î 0 0
 0 0 0
 0 0 î
:Fifth righthand Lalg generator of the su(3) fundamental IRR in the Gell-Mann basis

Ȼr6 = 1/2 *
 0 0 0
 1 0 0
 0 1 0
:Sixth righthand Lalg generator of the su(3) fundamental IRR in the Gell-Mann basis

Ȼr7 = 1/2 *
  0 0 0
 -î 0 0
  0 î 0
:Seventh righthand Lalg generator of the su(3) fundamental IRR in the Gell-Mann basis

Ȼr8 = 1/2√3 *
  0 0 1
  0 1 0
 -2 0 0
:Eighth righthand Lalg generator of the su(3) fundamental IRR in the Gell-Mann basis

Ȼr9 = 1/2 *
  0 0 0
  0 1 0
 -1 0 0
:Ninth righthand Lalg generator for the su(3) singlet IRR in the Gell-Mann basis

Ⱦ0
 1  0  0  0
 0  1  0  0
 0  0 -1  0
 0  0  0 -1
:First gamma matrix in the Dirac rep for 4-spinors

Ⱦ1
 0   0  0  1
 0   0  1  0
 0  -1  0  0
 -1  0  0  0
:Second gamma matrix in the Dirac rep for 4-spinors

Ⱦ2
  0  0  0 -î
  0  0  î  0
  0  î  0  0
 -î  0  0  0
:Third gamma matrix in the Dirac rep for 4-spinors

Ⱦ3
  0  0  1  0
  0  0  0 -1
 -1  0  0  0
  0  1  0  0
:Fourth gamma matrix in the Dirac rep for 4-spinors

Ⱦ5
 0  0  1  0
 0  0  0  1
 1  0  0  0
 0  1  0  0
:Fifth gamma matrix in the Dirac rep for 4-spinors.  γ5 = î γ0 γ1 γ2 γ3 in any rep.

Ⱦr0
 0  0  0  1
 0  0  1  0
 0 -1  0  0
 -1 0  0  0
:First righthand gamma matrix in the Dirac rep for 4-spinors

Ⱦr1
 1  0  0  0
 0  1  0  0
 0  0 -1  0
 0  0  0 -1
:Second righthand gamma matrix in the Dirac rep for 4-spinors

Ⱦr2
  -î 0  0  0
  0  î  0  0
  0  0  î  0
  0  0  0 -î
:Third righthand gamma matrix in the Dirac rep for 4-spinors

Ⱦr3
  0  1  0  0
 -1  0  0  0
  0  0  0 -1
  0  0  1  0
:Fourth righthand gamma matrix in the Dirac rep for 4-spinors

Ⱦr5
 0  1  0  0
 1  0  0  0
 0  0  0  1
 0  0  1  0
:Fifth righthand gamma matrix in the Dirac rep for 4-spinors.  γ5 = î γ0 γ1 γ2 γ3 in any rep.

Ħ1 = 2î *
 0 -1  0
 1  0  0
 0  0  0
:First Hermitian basis element for the adjoint IRR of su(2) in the Pauli basis

Ħ2 = 2î *
 0  0  0
 0  0 -1
 0  1  0
:Second Hermitian basis element for the adjoint IRR of su(2) in the Pauli basis

Ħ3 = 2î *
  0 0 1
  0 0 0
 -1 0 0
:Third Hermitian basis element for the adjoint IRR of su(2) in the Pauli basis.

Ħr1 = 2î *
 0 -1 0
 0  0 1
 0  0 0
:1st RH Hermitian basis element for the adjoint IRR of su(2) in the Pauli basis.

Ħr2 = 2î *
  0 0 0
 -1 0 0
  0 1 0
:2nd RH Hermitian basis element for the adjoint IRR of su(2) in the Pauli basis.

Ħr3 = 2î *
  1 0  0
  0 0  0
  0 0 -1
:3rd RH Hermitian basis element for the adjoint IRR of su(2) in the Pauli basis.

Ⱥ1 = -î *
 0 0 0 0 0 0 0 0
 0 0 1 0 0 0 0 0
 0 -1 0 0 0 0 0 0
 0 0 0 0 0 0 1/2 0
 0 0 0 0 0 -1/2 0 0
 0 0 0 0 1/2 0 0 0
 0 0 0 -1/2 0 0 0 0
 0 0 0 0 0 0 0 0
:First Hermitian basis element for the adjoint IRR of su(3) in the Gell-Mann basis

Ⱥ2 = -î *
 0 0 -1 0 0 0 0 0
 0 0 0 0 0 0 0 0
 1 0 0 0 0 0 0 0
 0 0 0 0 0 1/2 0 0
 0 0 0 0 0 0 1/2 0
 0 0 0 -1/2 0 0 0 0
 0 0 0 0 -1/2 0 0 0
 0 0 0 0 0 0 0 0
:Second Hermitian basis element for the adjoint IRR of su(3) in the Gell-Mann basis

Ⱥ3 = -î *
 0 1 0 0 0 0 0 0
 -1 0 0 0 0 0 0 0
 0 0 0 0 0 0 0 0
 0 0 0 0 1/2 0 0 0
 0 0 0 -1/2 0 0 0 0
 0 0 0 0 0 0 -1/2 0
 0 0 0 0 0 1/2 0 0
 0 0 0 0 0 0 0 0
:Third Hermitian basis element for the adjoint IRR of su(3) in the Gell-Mann basis.

Ⱥ4 = -î *
 0 0 0 0 0 0 -1/2 0
 0 0 0 0 0 -1/2 0 0
 0 0 0 0 1/2 0 0 0
 0 0 0 0 0 0 0 0
 0 0 -1/2 0 0 0 0 √3/2
 0 1/2 0 0 0 0 0 0
 1/2 0 0 0 0 0 0 0
 0 0 0 0 -√3/2 0 0 0
:Fourth Hermitian basis element for the adjoint IRR of su(3) in the Gell-Mann basis.

Ⱥ5 = -î *
 0 0 0 0 0 1/2 0 0
 0 0 0 0 0 0 -1/2 0
 0 0 0 1/2 0 0 0 0
 0 0 -1/2 0 0 0 0 -√3/2
 0 0 0 0 0 0 0 0
 -1/2 0 0 0 0 0 0 0
 0 1/2 0 0 0 0 0 0
 0 0 0 √3/2 0 0 0 0
:Fifth Hermitian basis element for the adjoint IRR of su(3) in the Gell-Mann basis.

Ⱥ6 = -î *
 0 0 0 0 -1/2 0 0 0
 0 0 0 1/2 0 0 0 0
 0 0 0 0 0 0 -1/2 0
 0 -1/2 0 0 0 0 0 0
 1/2 0 0 0 0 0 0 0
 0 0 0 0 0 0 0 0
 0 0 1/2 0 0 0 0 √3/2
 0 0 0 0 0 0 -√3/2 0
:Sixth Hermitian basis element for the adjoint IRR of su(3) in the Gell-Mann basis

Ⱥ7 = -î *
 0 0 0 1/2 0 0 0 0
 0 0 0 0 1/2 0 0 0
 0 0 0 0 0 -1/2 0 0
 -1/2 0 0 0 0 0 0 0
 0 -1/2 0 0 0 0 0 0
 0 0 1/2 0 0 0 0 -√3/2
 0 0 0 0 0 0 0 0
 0 0 0 0 0 √3/2 0 0
:Seventh Hermitian basis element for the adjoint IRR of su(3) in the Gell-Mann basis

Ⱥ8 = -î *
 0 0 0 0 0 0 0 0
 0 0 0 0 0 0 0 0
 0 0 0 0 0 0 0 0
 0 0 0 0 √3/2 0 0 0
 0 0 0 -√3/2 0 0 0 0
 0 0 0 0 0 0 √3/2 0
 0 0 0 0 0 -√3/2 0 0
 0 0 0 0 0 0 0 0
:Eighth Hermitian basis element for the adjoint IRR of su(3) in the Gell-Mann basis.

Ⱥr1 = -î *
 0 0 0 0 0 0 0 0
 0 0 0 0 0 1 0 0
 0 0 0 0 0 0 -1 0
 0 1/2 0 0 0 0 0 0
 0 0 -1/2 0 0 0 0 0
 0 0 0 1/2 0 0 0 0
 0 0 0 0 -1/2 0 0 0
 0 0 0 0 0 0 0 0
:1st RH Hermitian basis element for the adjoint IRR of su(3) in the Gell-Mann basis.

Ⱥr2 = -î *
 0 0 0 0 0 -1 0 0
 0 0 0 0 0 0 0 0
 0 0 0 0 0 0 0 1
 0 0 1/2 0 0 0 0 0
 0 1/2 0 0 0 0 0 0
 0 0 0 0 -1/2 0 0 0
 0 0 0 -1/2 0 0 0 0
 0 0 0 0 0 0 0 0
:2nd RH Hermitian basis element for the adjoint IRR of su(3) in the Gell-Mann basis

Ⱥr3 = -î *
 0 0 0 0 0 0 1 0
 0 0 0 0 0 0 0 -1
 0 0 0 0 0 0 0 0
 0 0 0 1/2 0 0 0 0
 0 0 0 0 -1/2 0 0 0
 0 -1/2 0 0 0 0 0 0
 0 0 1/2 0 0 0 0 0
 0 0 0 0 0 0 0 0
:3rd RH Hermitian basis element for the adjoint IRR of su(3) in the Gell-Mann basis.

Ⱥr4 = -î *
 0 -1/2 0 0 0 0 0 0
 0 0 -1/2 0 0 0 0 0
 0 0 0 1/2 0 0 0 0
 0 0 0 0 0 0 0 0
 √3/2 0 0 0 0 -1/2 0 0
 0 0 0 0 0 0 1/2 0
 0 0 0 0 0 0 0 1/2
 0 0 0 -√3/2 0 0 0 0
:4th RH Hermitian basis element for the adjoint IRR of su(3) in the Gell-Mann basis

Ⱥr5 = -î *
 0 0 1/2 0 0 0 0 0
 0 -1/2 0 0 0 0 0 0
 0 0 0 0 1/2 0 0 0
 -√3/2 0 0 0 0 -1/2 0 0
 0 0 0 0 0 0 0 0
 0 0 0 0 0 0 0 -1/2
 0 0 0 0 0 0 1/2 0
 0 0 0 0 √3/2 0 0 0
:5th RH Hermitian basis element for the adjoint IRR of su(3) in the Gell-Mann basis

Ⱥr6 = -î *
 0 0 0 -1/2 0 0 0 0
 0 0 0 0 1/2 0 0 0
 0 -1/2 0 0 0 0 0 0
 0 0 0 0 0 0 -1/2 0
 0 0 0 0 0 0 0 1/2
 0 0 0 0 0 0 0 0
 √3/2 0 0 0 0 1/2 0 0
 0 -√3/2 0 0 0 0 0 0
:6th RH Hermitian basis element for the adjoint IRR of su(3) in the Gell-Mann basis

Ⱥr7 = -î *
 0 0 0 0 1/2 0 0 0
 0 0 0 1/2 0 0 0 0
 0 0 -1/2 0 0 0 0 0
 0 0 0 0 0 0 0 -1/2
 0 0 0 0 0 0 -1/2 0
 -√3/2 0 0 0 0 1/2 0 0
 0 0 0 0 0 0 0 0
 0 0 √3/2 0 0 0 0 0
:7th RH Hermitian basis element for the adjoint IRR of su(3) in the Gell-Mann basis

Ⱥr8 = -î *
 0 0 0 0 0 0 0 0
 0 0 0 0 0 0 0 0
 0 0 0 0 0 0 0 0
 0 0 0 √3/2 0 0 0 0
 0 0 0 0 -√3/2 0 0 0
 0 √3/2 0 0 0 0 0 0
 0 0 -√3/2 0 0 0 0 0
 0 0 0 0 0 0 0 0
:8th RH Hermitian basis element for the adjoint IRR of su(3) in the Gell-Mann basis

