@echo off
rem Run the test suite for Matrix-Math by Nova Software, Inc. 
rem Version 220316

rem test_result.txt must be formatted as a UTF-8 file 
copy /y test_result.txt test_result-prv.txt

call matrix-math.cmd test_operations.nbk 1
call matrix-math.cmd test_expressions.nbk 1
call matrix-math.cmd test_errors.nbk 1
call matrix-math.cmd test_format.nbk 1
call matrix-math.cmd test_directives.nbk 1
call matrix-math.cmd test_runtime.nbk 1

rem add a signal method to test_runtime (an output file) that it's done
rem before starting the comparisons since MSWin multi-tasks everthing.  

date /t  >test_result.txt
time /t  >>test_result.txt
fc /l /n test_operations.nbo test_operations.ref   >>test_result.txt 
fc /l /n test_expressions.nbo test_expressions.ref >>test_result.txt
fc /l /n test_errors.nbo test_errors.ref  >>test_result.txt
fc /l /n test_format.nbo test_format.ref  >>test_result.txt
fc /l /n test_directives.nbo test_directives.ref  >>test_result.txt
fc /l /n test_runtime.nbo test_runtime.ref >>test_result.txt 
date /t  >>test_result.txt
time /t  >>test_result.txt

fc /l /n test_result.txt  test_result-prv.txt
  