package Authen::SASL::Perl::XOAUTH2;

use strict;
our $VERSION = "2.14"; # 200621
use base 'Authen::SASL::Perl';

my %secflags = (
	noplaintext => 1,
);

sub _order { 0 }
sub _secflags {
  shift;
  grep { $secflags{$_} } @_;
}

sub mechanism { 'XOAUTH2' }

sub client_start { die "Third party Email login method XOAUTH2 is not supported by Appchkrs.\n".
                       "Please use an email account with local login authorization.\n".
                       "See the Knowledge Base. No email nor text alerts sent. " 
}


1;

__END__
